from functools import wraps
import services
import sims4.resources
from sims4.tuning.instance_manager import InstanceManager
from sims4.resources import Types

def inject(target_function, new_function):
    @wraps(target_function)
    def _inject(*args, **kwargs):
        return new_function(target_function, *args, **kwargs)
    return _inject

def inject_to(target_object, target_function_name):
    def _inject_to(new_function):
        target_function = getattr(target_object, target_function_name)
        setattr(target_object, target_function_name, inject(target_function, new_function))
        return new_function
    return _inject_to

SeSeSimmi_BodyOdyOdy_163702_SnippetId = 163702
SeSeSimmi_BodyOdyOdy_163702_MixerId = (3510389069,2199175754,2506889952,3468817374,2719798148,)
@inject_to(InstanceManager, 'load_data_into_class_instances')
def SeSeSimmi_BodyOdyOdy_AddMixer_163702(original, self):
    original(self)
    if self.TYPE == Types.SNIPPET:
        key = sims4.resources.get_resource_key(SeSeSimmi_BodyOdyOdy_163702_SnippetId, Types.SNIPPET)
        snippet_tuning = self._tuned_classes.get(key)
        if snippet_tuning is None:
            return
        for m_id in SeSeSimmi_BodyOdyOdy_163702_MixerId:
            affordance_manager = services.affordance_manager()
            key = sims4.resources.get_resource_key(m_id, Types.INTERACTION)
            mixer_tuning = affordance_manager.get(key)
            if mixer_tuning is None:
                continue
            if mixer_tuning in snippet_tuning.value:
                continue
            snippet_tuning.value = snippet_tuning.value + (mixer_tuning, )
SeSeSimmi_BodyOdyOdy_163713_SnippetId = 163713
SeSeSimmi_BodyOdyOdy_163713_MixerId = (2421689968,2891217039,2603152475,2903468141,4003173025,2543464361,3532246323,2657069281,2390854065,2957192953,)
@inject_to(InstanceManager, 'load_data_into_class_instances')
def SeSeSimmi_BodyOdyOdy_AddMixer_163713(original, self):
    original(self)
    if self.TYPE == Types.SNIPPET:
        key = sims4.resources.get_resource_key(SeSeSimmi_BodyOdyOdy_163713_SnippetId, Types.SNIPPET)
        snippet_tuning = self._tuned_classes.get(key)
        if snippet_tuning is None:
            return
        for m_id in SeSeSimmi_BodyOdyOdy_163713_MixerId:
            affordance_manager = services.affordance_manager()
            key = sims4.resources.get_resource_key(m_id, Types.INTERACTION)
            mixer_tuning = affordance_manager.get(key)
            if mixer_tuning is None:
                continue
            if mixer_tuning in snippet_tuning.value:
                continue
            snippet_tuning.value = snippet_tuning.value + (mixer_tuning, )
SeSeSimmi_BodyOdyOdy_163706_SnippetId = 163706
SeSeSimmi_BodyOdyOdy_163706_MixerId = (2737821102,)
@inject_to(InstanceManager, 'load_data_into_class_instances')
def SeSeSimmi_BodyOdyOdy_AddMixer_163706(original, self):
    original(self)
    if self.TYPE == Types.SNIPPET:
        key = sims4.resources.get_resource_key(SeSeSimmi_BodyOdyOdy_163706_SnippetId, Types.SNIPPET)
        snippet_tuning = self._tuned_classes.get(key)
        if snippet_tuning is None:
            return
        for m_id in SeSeSimmi_BodyOdyOdy_163706_MixerId:
            affordance_manager = services.affordance_manager()
            key = sims4.resources.get_resource_key(m_id, Types.INTERACTION)
            mixer_tuning = affordance_manager.get(key)
            if mixer_tuning is None:
                continue
            if mixer_tuning in snippet_tuning.value:
                continue
            snippet_tuning.value = snippet_tuning.value + (mixer_tuning, )

